<?php
// $Id: logo.php,v 1.3 2007/04/12 13:51:04 pobster Exp $

/**
 * Create an image and display a message in it (for error reporting)
 */
function logotool_display_error($text = "Error Creating Logo") {
  $im = imagecreate(181, 20);
  $bg = imagecolorallocate($im, 255, 255, 255);
  $textcolor = imagecolorallocate($im, 255, 0, 0);
  imagestring($im, 5, 2, 1, $text, $textcolor);
  header("Content-type: image/png");
  imagepng($im);
  imagedestroy($im);
} // logotool_display_error

// Include a few Drupal files and allow us to access 'variable_get'
include_once('./includes/image.inc');
include_once('./includes/file.inc');
include_once('./includes/bootstrap.inc');
drupal_bootstrap(DRUPAL_BOOTSTRAP_LATE_PAGE_CACHE);
define('LT_CWD', file_directory_path().'/logos');

// Check whether there's a logo path supplied (and make sure it resides in the logos directory to prevent exploits)
// else use the logo contained in the logotool_logo variable
$logo = $_GET['logo'] ? $_GET['logo'] : variable_get('logotool_logo', '');
$logo = realpath(file_check_location(sprintf("%s/%s", variable_get('logotool_folder', LT_CWD), $logo), variable_get('logotool_folder', LT_CWD)));

// If logo doesn't exist return an error
if (!$logo && variable_get('logotool_logo', '') != variable_get('logotool_path', 'misc/druplicon.png')) {
  logotool_display_error("Logo Not Found");
  return;
}
elseif (!$logo && variable_get('logotool_logo', '') == variable_get('logotool_path', 'misc/druplicon.png')) {
  $logo = variable_get('logotool_path', 'misc/druplicon.png');
}

// Return image information
$info = image_get_info($logo);

// If file is not an image file (or is unsupported) then return an error
if (!$info['mime_type']) {
  logotool_display_error("Unsupported Filetype");
  return;
}

// Display headers so browser knows we're outputting an image
$headers = array('Content-Type: '.$info['mime_type']);
foreach ($headers as $header) {
  header($header);
}

// Output image
$im = @readfile($logo);

// If there's been a problem, report it
if (!$im) logotool_display_error();
